Index: include/wingdi.h
===================================================================
@@ -1384,10 +1388,11 @@ typedef struct
 #define TT_POLYGON_TYPE 24
 
 /* Get/SetSystemPaletteUse() values */
-#define SYSPAL_ERROR    0
-#define SYSPAL_STATIC   1
-#define SYSPAL_NOSTATIC 2
-
+#define SYSPAL_ERROR        0
+#define SYSPAL_STATIC       1
+#define SYSPAL_NOSTATIC     2
+#define SYSPAL_NOSTATIC256  3
+    
 #ifndef _PALETTEENTRY_DEFINED
 #define _PALETTEENTRY_DEFINED
 typedef struct tagPALETTEENTRY
Index: objects/palette.c
===================================================================
RCS file: /home/wine/wine/objects/palette.c,v
retrieving revision 1.54
diff -u -3 -p -u -r1.54 palette.c
--- objects/palette.c	22 Nov 2002 22:16:53 -0000	1.54
+++ objects/palette.c	26 Jan 2003 00:39:58 -0000
@@ -454,9 +454,26 @@ UINT WINAPI SetSystemPaletteUse(
     UINT use) /* [in] Palette-usage flag */
 {
     UINT old = SystemPaletteUse;
-    FIXME("(%p,%04x): stub\n", hdc, use );
-    SystemPaletteUse = use;
-    return old;
+    
+    /* Device context is invalid */
+    if (hdc == NULL) {
+        return SYSPAL_ERROR;
+    }
+    
+    /* Device doesn't support colour palettes */
+    if (!(GetDeviceCaps(hdc, RASTERCAPS) & RC_PALETTE)) {
+        return SYSPAL_ERROR;
+    }
+    
+    switch (use) {
+        case SYSPAL_NOSTATIC:
+        case SYSPAL_NOSTATIC256:        /* WINVER >= 0x0500 */ 
+        case SYSPAL_STATIC:
+            SystemPaletteUse = use;
+            return old;
+        default:
+            return SYSPAL_ERROR;
+    }    
 }
